## fungw 1.2.0

=== src_3rd/genht/Makefile ===
# use -DGENHT_WANT_INLINE to turn half of the API into static inline functions
PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genht
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib

HOSTCC = $(CC)

VER_MAJOR=1
VER_MINOR=1
VER_PATCH=1
VER=$(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

CFLAGS=-g $(GENHT_CFLAGS)
LDFLAGS=$(GENHT_LDFLAGS)

BIN=mainsi
OBJS=htss.o htsp.o htsi.o htip.o htpp.o htpi.o hash.o siphash24.o
LIBSO=libgenht.so.$(VER)
LIBSO1=libgenht.so.$(VER_MAJOR)
LIBA=libgenht.a

all: version.h $(BIN) $(OBJS) $(LIBA) $(LIBSO)

clean:
	-rm $(BIN) $(OBJS) $(LIBA) $(LIBSO) genht_std.so genht_std.a version.h ver_edit

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) -o $@ -c -fPIC $< $(CFLAGS)

mainsi: mainsi.o htsi.o
	$(CC) -o $@ mainsi.o htsi.o $(LDFLAGS)

$(LIBSO): $(OBJS)
	$(CC) $(LDFLAGS) -shared -dynamic -rdynamic -o $@ $(OBJS)

$(LIBA): $(OBJS)
	ar rvu $@ $(OBJS)
	-ar s $@
	-ranlib $@

# for compatibility
genht_std.so: $(LIBSO)
	ln -s $(LIBSO) genht_std.so

# for compatibility
genht_std.a: $(LIBA)
	ln -s $(LIBA) genht_std.a

version.h: version.h.in ver_edit
	./ver_edit $(VER_MAJOR) $(VER_MINOR) $(VER_PATCH) < version.h.in > version.h

ver_edit: ver_edit.c
	$(HOSTCC) -o $@ $(CFLAGS) ver_edit.c

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/hash.h $(INCDIR)/hash.h
	$(CP) `pwd`/siphash24.h $(INCDIR)/siphash24.h
	$(CP) `pwd`/ht.h $(INCDIR)/ht.h
	$(CP) `pwd`/ht.c $(INCDIR)/ht.c
	$(CP) `pwd`/version.h $(INCDIR)/version.h
	$(CP) `pwd`/ht_inlines.h $(INCDIR)/ht_inlines.h
	$(CP) `pwd`/ht_utils.h $(INCDIR)/ht_utils.h
	$(CP) `pwd`/htip.h $(INCDIR)/htip.h
	$(CP) `pwd`/htpi.h $(INCDIR)/htpi.h
	$(CP) `pwd`/htsi.h $(INCDIR)/htsi.h
	$(CP) `pwd`/htsp.h $(INCDIR)/htsp.h
	$(CP) `pwd`/htss.h $(INCDIR)/htss.h
	$(CP) `pwd`/htpp.h $(INCDIR)/htpp.h
	$(CP) `pwd`/$(LIBSO) $(LIBDIR)/$(LIBSO)
	$(CP) `pwd`/$(LIBA) $(LIBDIR)/$(LIBA)

uninstall:
	rm -rf $(INCDIR)
	rm $(LIBDIR)/$(LIBSO) $(LIBDIR)/$(LIBA) $(LIBDIR)/$(LIBSO1)

install:
	make install_ CP="cp"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

linstall:
	make install_ CP="ln -s"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

test: mainsi
	@./mainsi > mainsi.out
	@diff mainsi.ref mainsi.out
	@echo "*** QC pass ***"

=== debian/changelog ===
fungw (1.2.0-4build1) jammy; urgency=medium

  * No-change rebuild against libduktape207

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Mar 2022 17:13:40 +0000

fungw (1.2.0-4) unstable; urgency=medium

  * also need to not try and build libfungw-mruby1 on arm64

 -- Bdale Garbee <bdale@gag.com>  Fri, 18 Feb 2022 09:23:17 -0700

fungw (1.2.0-3) unstable; urgency=medium

  * a better fix for arm64 would be to elide mruby support there for now

 -- Bdale Garbee <bdale@gag.com>  Fri, 18 Feb 2022 00:23:57 -0700

fungw (1.2.0-2) unstable; urgency=medium

  * add mruby to build deps to (hopefully!) resolve -fPIC issue on arm64

 -- Bdale Garbee <bdale@gag.com>  Thu, 17 Feb 2022 23:33:49 -0700

fungw (1.2.0-1) unstable; urgency=medium

  * Initial packaging

 -- Bdale Garbee <bdale@gag.com>  Sat, 09 Oct 2021 10:25:23 -0600

=== debian/control ===
Source: fungw
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>= 11), libmawk-dev, liblua5.3-dev | liblua5.2-dev | liblua5.1-0-dev, duktape-dev, libmruby-dev [!arm64], libperl-dev, libpython3-dev, tcl-dev
Standards-Version: 4.1.3
Homepage: http://repo.hu/projects/fungw
Vcs-Svn: svn://svn.repo.hu/fungw/trunk

Package: fungw
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1, libfungw-fawk1, libfungw-cli1
Description: Standard installation of libfungw
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs fungw core and support for a few very small
 scripting languages.

Package: libfungw1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Core fungw library with the API
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs fungw core library that provides the API, but
 does not contain any scripting language binding.

Package: libfungw-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Core fungw library with the API
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package constains all header files to allow applications to compile
 with fungw.

Package: libfungw-fawk1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: fawk, fpas and fbas
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the interpreter and fungw binding of fawk
 (function-awk), fbas (function-BASIC) and fpas (function-PASCAL)

Package: libfungw-cli1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: external languages (bash)
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the binding to scripting languages ran as
 an external process. Currently supported language is bash.


Package: libfungw-mawk1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: mawk
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for mawk.

Package: libfungw-lua1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: lua
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for lua.

Package: libfungw-duktape1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: Javascript
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for Javascript (using
 duktape).

Package: libfungw-mruby1
Architecture: amd64 armel armhf i386 mips64el mipsel ppc64el s390x hurd-i386 m68k powerpc ppc64 riscv64 sh4
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: ruby
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for ruby (using mruby).

Package: libfungw-perl1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: perl
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for perl.

Package: libfungw-python3-1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: python3
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for python 3.

Package: libfungw-tcl1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
Description: Scripting support for fungw: tcl
 Fungw is a tiny, portable library written in C (C89) that manages
 dynamic function calls across different programming languages.
 .
 This package installs the language binding for tcl.

## fungw 1.2.1

=== Makefile ===
all:
	cd libfungw && make all
	cd libfungwbind && make all
	cd regression && make all
	cd doc && make all

clean:
	cd libfungw && make clean
	cd libfungwbind && make clean
	cd regression && make clean
	cd doc && make clean
	-cd src_3rd/genht && make clean

distclean:
	cd regression && make distclean
	cd libfungw && make distclean
	cd libfungwbind && make distclean
	cd doc && make distclean
	cd scconfig && make distclean
	-cd src_3rd/genht && make clean

install:
	cd libfungw && make install
	cd libfungwbind && make install
	cd doc && make install


linstall:
	cd libfungw && make linstall
	cd libfungwbind && make linstall
	cd doc && make linstall

uninstall:
	cd libfungw && make uninstall
	cd libfungwbind && make uninstall
	cd doc && make uninstall

=== scconfig/Makefile ===
# --- configuration part --

# - generic configuration -
#  where scconfig source is; this is a path to a partial or full checkout of
#  svn://repo.hu/scconfig/trunk/src
SRC=src/

#  where compiled binaries (e.g. objects) should land; should be the same as
#  $(SRC) the project has its own copy of scconfig embedded
BIN=src/

#  what cflags to use to compile scconfig
USER_CFLAGS = -Wall -g -DGENCALL

#  what ldflags to use to link scconfig
USER_LDFLAGS =

#  in case hooks.c needs to link to something local
USER_OBJS =

#  what to build - a ./configure
all: configure

# This line imports scconfig core and default tests
include $(SRC)/default/Makefile.plugin

#
# - PLUGINS -
#
#  Comment this line if you are not interested in c99 features
#include $(SRC)/c99/Makefile.plugin

#  Comment this line if you do not need script libs to be detected
include $(SRC)/scripts/Makefile.plugin

#  Comment this line if you do not need parser libs to be detected
#include $(SRC)/parser/Makefile.plugin

#  Comment this line if you do not need to detect parser generators
#include $(SRC)/parsgen/Makefile.plugin

#  Comment this line if you do not need math related libs
#include $(SRC)/math/Makefile.plugin

#  Comment this line if you do not need socket/networking
#include $(SRC)/socket/Makefile.plugin

#  Comment this line if you do not need user/password API detection
#include $(SRC)/userpass/Makefile.plugin

#  Comment this line if you do not need gui (X11, toolkits)
#include $(SRC)/gui/Makefile.plugin

#  Comment this line if you do not need software utility libs (glib)
#include $(SRC)/sul/Makefile.plugin

#  Uncomment this line if you need menus
#include $(SRC)/menulib/Makefile.plugin

#  Comment this line if you do not need generator (templating); conflicts with tmpasm
#include $(SRC)/generator/Makefile.plugin

#  Comment this line if you do not need tmpasm (templating); conflicts with generator
include $(SRC)/tmpasm/Makefile.plugin

# --- you shouldn't edit the lines below ---
OBJS = $(USER_OBJS) hooks.o $(DEFAULT_NOMAIN_OBJS) $(SCRIPT_OBJS) $(PARSER_OBJS) $(GENERATOR_OBJS) $(TMPASM_OBJS) $(C99_OBJS) $(PARSGEN_OBJS) $(MATH_OBJS) $(SOCKET_OBJS) $(USERPASS_OBJS) $(GUI_OBJS) $(SUL_OBJS)
CFLAGS = $(USER_CFLAGS) $(DEFAULT_CFLAGS) $(SCRIPT_CFLAGS) $(PARSER_CFLAGS) $(GENERATOR_CFLAGS) $(TMPASM_CFLAGS) $(C99_CFLAGS) $(PARSGEN_CFLAGS) $(MATH_CFLAGS) $(SOCKET_CFLAGS) $(USERPASS_CFLAGS) $(GUI_CFLAGS)  $(SUL_CFLAGS) $(MENULIB_CFLAGS) -I$(SRC)/default
LDFLAGS = $(USER_LDFLAGS) $(DEFAULT_LDFLAGS) $(SCRIPT_LDFLAGS) $(PARSER_LDFLAGS) $(GENERATOR_LDFLAGS) $(TMPASM_LDFLAGS) $(C99_LDFLAGS) $(PARSGEN_LDFLAGS) $(MATH_LDFLAGS) $(SOCKET_LDFLAGS) $(USERPASS_LDFLAGS) $(GUI_LDFLAGS) $(SUL_LDFLAGS) $(MENULIB_LDFLAGS)

all: configure sccbox cquote

configure: $(OBJS) $(DEFAULT_MAIN_OBJS)
	$(CC) -o configure $(OBJS) $(DEFAULT_MAIN_OBJS)

menuconfig: $(OBJS) $(MENULIB_OBJS)
	$(CC) -o configure $(OBJS) $(MENULIB_OBJS)

src/util/sccbox.o: src/util/sccbox.c
	$(CC) -c $(CFLAGS) -o src/util/sccbox.o src/util/sccbox.c

sccbox: src/util/sccbox.o
	$(CC) $(LDFLAGS) -o sccbox src/util/sccbox.o

src/util/cquote.o: src/util/cquote.c
	$(CC) -c $(CFLAGS) -o src/util/cquote.o src/util/cquote.c

cquote: src/util/cquote.o
	$(CC) $(LDFLAGS) -o cquote src/util/cquote.o

hooks.o: ../libfungw/scconfig_hooks.h ../libfungwbind/scconfig_hooks.h

clean:
	rm $(OBJS) $(DEFAULT_MAIN_OBJS) configure sccbox cquote

distclean: clean
	-rm config.cache config.log

=== doc/example/00_hello/Makefile ===
all:

#nothing to do

clean:

#nothing to do

=== debian/changelog ===
fungw (1.2.1-3build5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:00:36 +0000

fungw (1.2.1-3build4) noble; urgency=medium

  * No-change rebuild against libperl5.38t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 18:19:25 +0000

fungw (1.2.1-3build3) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:09:35 +0100

fungw (1.2.1-3build2) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 19:20:53 +0000

fungw (1.2.1-3build1) noble; urgency=medium

  * No-change rebuild for the perl update.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Jan 2024 14:04:10 +0100

fungw (1.2.1-3) unstable; urgency=medium

  * change control file VCS references to Debian salsa packaging repo

 -- Bdale Garbee <bdale@gag.com>  Mon, 12 Jun 2023 09:09:29 -0600

fungw (1.2.1-2) unstable; urgency=medium

  * turn off mruby support, since it's keeping us out of testing with no
    prognosis on resolution of the string of mruby CVEs

 -- Bdale Garbee <bdale@gag.com>  Thu, 08 Sep 2022 15:10:43 -0600

fungw (1.2.1-1) unstable; urgency=medium

  * new upstream version, closes: #1009416

 -- Bdale Garbee <bdale@gag.com>  Mon, 25 Apr 2022 12:05:25 -0500

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,11 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Bdale Garbee <bdale@gag.com>
-Build-Depends: debhelper (>= 11), libmawk-dev, liblua5.3-dev | liblua5.2-dev | liblua5.1-0-dev, duktape-dev, libmruby-dev [!arm64], libperl-dev, libpython3-dev, tcl-dev
+Build-Depends: debhelper (>= 11), libmawk-dev, liblua5.3-dev | liblua5.2-dev | liblua5.1-0-dev, duktape-dev, libperl-dev, libpython3-dev, tcl-dev
 Standards-Version: 4.1.3
 Homepage: http://repo.hu/projects/fungw
-Vcs-Svn: svn://svn.repo.hu/fungw/trunk
+Vcs-Git: https://salsa.debian.org/electronics-team/fungw.git
+Vcs-Browser: https://salsa.debian.org/electronics-team/fungw
 
 Package: fungw
 Architecture: any
@@ -89,15 +90,6 @@
  This package installs the language binding for Javascript (using
  duktape).
 
-Package: libfungw-mruby1
-Architecture: amd64 armel armhf i386 mips64el mipsel ppc64el s390x hurd-i386 m68k powerpc ppc64 riscv64 sh4
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)
-Description: Scripting support for fungw: ruby
- Fungw is a tiny, portable library written in C (C89) that manages
- dynamic function calls across different programming languages.
- .
- This package installs the language binding for ruby (using mruby).
-
 Package: libfungw-perl1
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, libfungw1 (>= ${source:Version}), libfungw1 (<< ${source:Version}.1~)

## fungw 1.2.2

=== Makefile ===
all:
	cd libfungw && $(MAKE) all
	cd libfungwbind && $(MAKE) all
	cd regression && $(MAKE) all
	cd doc && $(MAKE) all

clean:
	cd libfungw && $(MAKE) clean
	cd libfungwbind && $(MAKE) clean
	cd regression && $(MAKE) clean
	cd doc && $(MAKE) clean
	-cd src_3rd/genht && $(MAKE) clean

distclean: clean
	cd regression && $(MAKE) distclean
	cd libfungw && $(MAKE) distclean
	cd libfungwbind && $(MAKE) distclean
	cd doc && $(MAKE) distclean
	cd scconfig && $(MAKE) distclean
	-cd src_3rd/genht && $(MAKE) clean

install:
	cd libfungw && $(MAKE) install
	cd libfungwbind && $(MAKE) install
	cd doc && $(MAKE) install


linstall:
	cd libfungw && $(MAKE) linstall
	cd libfungwbind && $(MAKE) linstall
	cd doc && $(MAKE) linstall

uninstall:
	cd libfungw && $(MAKE) uninstall
	cd libfungwbind && $(MAKE) uninstall
	cd doc && $(MAKE) uninstall

=== scconfig/Makefile ===
--- 
+++ 
@@ -91,7 +91,7 @@
 hooks.o: ../libfungw/scconfig_hooks.h ../libfungwbind/scconfig_hooks.h
 
 clean:
-	rm $(OBJS) $(DEFAULT_MAIN_OBJS) configure sccbox cquote
+	rm $(OBJS) src/util/sccbox.o src/util/cquote.o $(DEFAULT_MAIN_OBJS) configure sccbox cquote
 
 distclean: clean
 	-rm config.cache config.log

=== doc/example/10_script/Makefile ===
all: test_script

#CFLAGS_DBG = -g -Wall
include ../Makefile.conf

test_script: test_script.o
	$(CC) -o test_script test_script.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS) $(FUNGWBIND_SRCLIBA)

test_script.o: test_script.c
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o test_script.o test_script.c

clean:
	-rm test_script test_script.o 2>/dev/null

=== doc/example/15_c_call_script/Makefile ===
all: calls

#CFLAGS_DBG = -g -Wall
include ../Makefile.conf

calls: calls.o
	$(CC) -o calls calls.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS)  $(FUNGWBIND_SRCLIBA)

calls.o: calls.c
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o calls.o calls.c

clean:
	-rm calls calls.o 2>/dev/null

=== doc/example/30_lnk_sys_pup/Makefile ===
# User configuration for this example: change default language and script
# file name; these can be overriden runtime from the command line
# Prefix is where fungw is installed
PREFIX=/usr/local/lib
SCLANG=fawk
SCRIPT_FN=../00_hello/hello.fawk
#CFLAGS_DBG = -g -Wall


FUNGW=$(PREFIX)/fungw

# You have to have genht installed too
LDFLAGS_FUNGW=-lfungw -lpuplug -ldl -lgenht

# this is how language and script file name is passed in for the example code
# so it doesn't need to do any parsing or run-time decision
CFLAGS_LANG = \
	-DSCLANG=$(SCLANG) \
	-DSCLANG_STR=\"$(SCLANG)\" \
	-DSCRIPT_FN=\"$(SCRIPT_FN)\" \
	-DPREFIX=\"$(PREFIX)\"

all: hello

hello: hello.o
	$(CC) -o hello hello.o $(LDFLAGS) $(LDFLAGS_SCRIPT) $(LDFLAGS_FUNGW) -lm $(LDLIBS)

hello.o: hello.c Makefile
	$(CC) -c $(CFLAGS) $(CFLAGS_LANG) $(CFLAGS_SCRIPT) $(CFLAGS_DBG) -o hello.o hello.c

clean:
	-rm hello hello.o 2>/dev/null

=== doc/example/31_lnk_sys_dl/Makefile ===
# User configuration for this example: change default language and script
# file name; these can be overriden runtime from the command line
# Prefix is where fungw is installed
PREFIX=/usr/local/lib
SCLANG=fawk
SCRIPT_FN=../00_hello/hello.fawk
#CFLAGS_DBG = -g -Wall


FUNGW=$(PREFIX)/fungw

# You have to have genht installed too
LDFLAGS_FUNGW=-lfungw -ldl -lgenht

# this is how language and script file name is passed in for the example code
# so it doesn't need to do any parsing or run-time decision
CFLAGS_LANG = \
	-DSCLANG=$(SCLANG) \
	-DSCLANG_STR=\"$(SCLANG)\" \
	-DSCRIPT_FN=\"$(SCRIPT_FN)\" \
	-DPREFIX=\"$(PREFIX)\"

all: hello

hello: hello.o
	$(CC) -o hello hello.o $(LDFLAGS) $(LDFLAGS_SCRIPT) $(LDFLAGS_FUNGW) -lm $(LDLIBS)

hello.o: hello.c Makefile
	$(CC) -c $(CFLAGS) $(CFLAGS_LANG) $(CFLAGS_SCRIPT) $(CFLAGS_DBG) -o hello.o hello.c

clean:
	-rm hello hello.o 2>/dev/null

=== doc/example/32_lnk_sys_dyn/Makefile ===
# User configuration for this example: change language and script file name
# Prefix is where fungw is installed
PREFIX=/usr/local/lib
SCLANG=fawk
SCRIPT_FN=../00_hello/hello.fawk
#CFLAGS_DBG = -g -Wall

# this variable-in-variable needs a fairly recent make implementation
# should work with GNU make and any modern BSD make. In a more portable
# project the available libs are detected in ./configure and these can
# be generated.
LDFLAGS_SCRIPT = -lfungw_$(SCLANG) $(LDFLAGS_fungw_$(SCLANG))
CFLAGS_SCRIPT = $(CFLAGS_fungw_$(SCLANG))

include $(PREFIX)/puplug/fungw_$(SCLANG).mak
FUNGW=$(PREFIX)/fungw

# You have to have genht installed too
LDFLAGS_FUNGW=-lfungw -lgenht 

# this is how language and script file name is passed in for the example code
# so it doesn't need to do any parsing or run-time decision
CFLAGS_LANG = \
	-DSCLANG=$(SCLANG) \
	-DSCLANG_STR=\"$(SCLANG)\" \
	-DSCRIPT_FN=\"$(SCRIPT_FN)\"

all: hello

hello: hello.o
	$(CC) -o hello hello.o $(LDFLAGS) $(LDFLAGS_SCRIPT) $(LDFLAGS_FUNGW) -lm $(LDLIBS)

hello.o: hello.c Makefile
	$(CC) -c $(CFLAGS) $(CFLAGS_LANG) $(CFLAGS_SCRIPT) $(CFLAGS_DBG) -o hello.o hello.c

clean:
	-rm hello hello.o 2>/dev/null

=== doc/example/60_engine_c/Makefile ===
all: test_math

#CFLAGS_DBG = -g -Wall
include ../Makefile.conf

# $(FUNGWBIND_SRCLIBA) is explained in 10_script

test_math: test_math.o eng_math.o
	$(CC) -o test_math test_math.o eng_math.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS) $(FUNGWBIND_SRCLIBA)

test_math.o: test_math.c eng_math.h
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o test_math.o test_math.c

eng_math.o: eng_math.c eng_math.h
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o eng_math.o eng_math.c

clean:
	-rm test_math test_math.o eng_math.o 2>/dev/null

=== doc/example/80_multicall/Makefile ===
all: multicall

#CFLAGS_DBG = -g -Wall
include ../Makefile.conf

multicall: multicall.o
	$(CC) -o multicall multicall.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS)

multicall.o: multicall.c
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o multicall.o multicall.c

clean:
	-rm multicall multicall.o 2>/dev/null

=== doc/example/82_ucc/Makefile ===
all: test_script

CFLAGS_DBG = -g -Wall
include ../Makefile.conf

# $(FUNGWBIND_SRCLIBA) contains all static linkable script languages.
# Linking them all is suboptimal for a real application because:
#  - it hardwires language support to whatever is available at the time the
#    app is compiled
#  - it brings in a lot of unnecessary dependencies, e.g. if you use lua only
#    but you had python available at app compialtion time, every time you
#    start the app it will dynamic link python as well
#
# We use this suboptimal method here because it's just a quick example and
# this makes it easier to change scripting languages while keeping the build
# simple. There are other exmaples further down that demonstrate different
# build/link strategies.

test_script: test_script.o
	$(CC) -o test_script test_script.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS) $(FUNGWBIND_SRCLIBA)

test_script.o: test_script.c
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o test_script.o test_script.c

clean:
	-rm test_script test_script.o 2>/dev/null

=== doc/example/87_custom_type/Makefile ===
all: custype_prop custype_lazy

CFLAGS_DBG = -g -Wall
include ../Makefile.conf

custype_prop: custype_prop.o
	$(CC) -o custype_prop custype_prop.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS)

custype_prop.o: custype_prop.c
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o custype_prop.o custype_prop.c

custype_lazy: custype_lazy.o
	$(CC) -o custype_lazy custype_lazy.o $(LDFLAGS) $(LIB_FGW) $(LDLIBS)

custype_lazy.o: custype_lazy.c
	$(CC) -c $(CFLAGS) $(CFLAGS_DBG) -o custype_lazy.o custype_lazy.c

clean:
	-rm custype_prop custype_prop.o custype_lazy custype_lazy.o 2>/dev/null

=== debian/changelog ===
fungw (1.2.2-1) unstable; urgency=medium

  * new upstream version
  * move fungw into the Ringdove suite on salsa

 -- Bdale Garbee <bdale@gag.com>  Wed, 17 Sep 2025 19:17:19 -0600

fungw (1.2.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "ftbfs with GCC-14": add patch frm ntyni to add explicit void pointer
    cast for Perl user data. (Closes: #1074973)

 -- gregor herrmann <gregoa@debian.org>  Sat, 10 Aug 2024 03:31:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: fungw
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
+Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Bdale Garbee <bdale@gag.com>
-Build-Depends: debhelper (>= 11), libmawk-dev, liblua5.3-dev | liblua5.2-dev | liblua5.1-0-dev, duktape-dev, libperl-dev, libpython3-dev, tcl-dev
+Build-Depends: debhelper-compat (= 11), libmawk-dev, liblua5.3-dev | liblua5.2-dev | liblua5.1-0-dev, duktape-dev, libperl-dev, libpython3-dev, tcl-dev
 Standards-Version: 4.1.3
 Homepage: http://repo.hu/projects/fungw
-Vcs-Git: https://salsa.debian.org/electronics-team/fungw.git
-Vcs-Browser: https://salsa.debian.org/electronics-team/fungw
+Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/fungw.git
+Vcs-Browser: https://salsa.debian.org/electronics-team/ringdove-eda/fungw
 
 Package: fungw
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

override_dh_auto_clean:
	# only try to run dh_auto_clean if configure has been run
	test -f libfungw/Makefile && dh_auto_clean || true

override_dh_auto_configure:
	./configure \
		--LDFLAGS='$(LDFLAGS)' \
		--CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
		\
		--prefix=/usr \

# this is needed to work around the DOCDIR bug - version > 1.1.0 won't need it
override_dh_install:
	make install DESTDIR=$(CURDIR)/debian/tmp DOCDIR=$(CURDIR)/debian/tmp/usr/share/doc/libfungw
	dh_install

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack.*$// \
  http://www.repo.hu/projects/fungw/releases/fungw-(.*)\.tar\.gz
